#define ATSP_DECELERATION 19.5F // 萔 (x[km/h/s] x 7.2)
// 19.5=55^2/(180-25)
#define ATSP_OFFSET 0.5F // ԏqItZbg[m]
#define ATSP_VO 25 // ~\_M@܂ł̋[m]

class CAtsp
{
private:
	float m_DistSig; // ~\_܂ł̋[m]
	float m_DistLimSpd; // xʒu܂ł̋[m]
	int m_target; // ڕWx[km/h]
	int m_limSpd; // x[km/h]
	int m_maxSpd; // ōx[km/h]
	int m_approachLampOld; // Õp^[ڋߕ\
	int m_bell; // PŃx̏

	void applyBrake(int); // u[L
	void startAtsp(void); // ATS-P
	void blowBell(bool); // PŃx炷
	void applyEmgBrake(void); // u[L
	void init(void); // ϐ̏

public:
	float *TrainSpeed; // ԑx[km/h]
	int *DeltaT; // t[[ms/frame]
	int *BrakeNotch; // u[Lmb`
	int *Reverser; // o[T[ʒu
    int EmergencyNotch; // ԗ̔mb`
	int ServiceNotch; // ԗATSmFmb`
	int Bell; // PŃx
	int ApproachLamp; // p^[ڋߕ\
	int BrakeApplyLamp; // u[L\
	int AtspLamp; // ATS-P\
	bool ServiceBrake; // pu[L
	bool EmergencyBrake; // u[L
    
	CAtsp(void);
	virtual ~CAtsp(void);
	void RunP(void);
	void InitP(void);
	void PassedSig(float);
	void PassedStopEmg(float);
	void PassedStopSvc(float);
	void PassedSpeedLim(int, int);
	void PassedSpeedMax(int);
	void Reset(void);
	void Exit(void);
};
